### PARAMETERS ###
exports.highestYInList = 0
exports.showGrid = yes
exports.gridHeightForiPhone5 = 140
exports.gridHeightForiPhone6 = 160
exports.subTitleOnIphone5 = yes
exports.subTitleOnIphone6 = yes
exports.scaleForiPhone5 = 1
exports.scaleForiPhone6 = 1

### COLORS ###
exports.blue = "#28AFFA"
exports.purple = "#877DD7"
exports.teal = "#2DD7AA"
exports.green = "#7DDD11"
exports.orange = "#F8B000"

exports.color_big_text = "white"
exports.color_text = "white"

if Utils.isPhone() or (Framer.Device.deviceType.substring 0, 12) is "apple-iphone"
	exports.color_big_text = "black"
	exports.color_text = "white"

### GRID ###
if grid?
	if grid.height is 1
		@gridOrLine = "line"
	else
		@gridOrLine = "grid"
		grid.props =
			image: "modules/images/gridlines.png"
			style:
				backgroundPosition: "0px 0px"
				backgroundRepeat: "repeat"
				backgroundSize: "auto"


### MAKE EVENT LISTS ###
exports.containers = []
exports.alldots = []
exports.pageIndicators = []

exports.makeEventsLists = (eventsLists) -> 

	for page, i in eventsLists

		if i is 0
			xPositionPage = 50
		else if i is 1
			xPositionPage = grid.x + ( (grid.width - 140) / 3 ) + 70
			if @gridOrLine is "line"
				xPositionPage = xPositionPage - 40
		else if i is 2
			xPositionPage = grid.x + ( (grid.width - 140) / 3 * 2 ) + 140
			if @gridOrLine is "line"
				xPositionPage = xPositionPage - 25


		container = new Layer
			x: xPositionPage
			y: grid.maxY + 27
			backgroundColor: null
			width: 290
			height: Screen.height - grid.maxY - 40
			name: page.color
			originX: 0
			originY: 0

		exports.containers.push container


		currentY = 0

		for list, i in page.lists

			title = new TextLayer
				width: container.width
				height: 35
				y: currentY
				color: @color_text
				text: list.title
				fontFamily: Title.fontFamily
				fontWeight: 300
				fontSize: 28
				parent: container
			

			currentY += 35

			for item, i in list.items

				white_dot = new Layer
					size: 30
					borderRadius: 15
					backgroundColor: "white"
					x: title.x + 2
					y: currentY + 19
					parent: container

				dot = new Layer
					size: 20
					borderRadius: 10
					backgroundColor: "#28AFFA"
					point: 5
					opacity: 0
					parent: white_dot
					name: item

				dot.states.active =
					opacity: 1
					scale: 1.5

				exports.alldots.push dot

				dot_label = new TextLayer
					x: title.x
					y: currentY + 22
					color: exports.color_text
					text: item
					fontFamily: "Menlo, Monaco, Courier, monospace"
					fontSize: 18
					padding:
						left: 44
					parent: container


				currentY += 46

			currentY += 30

			if exports.highestYInList < currentY
				exports.highestYInList = currentY


### PAGE COMPONENT FOR PHONES ###
if Utils.isPhone() or (Framer.Device.deviceType.substring 0, 12) is "apple-iphone"
	exports.page = new PageComponent
		width: Screen.width
		scrollVertical: no

### REFLOW LAYOUT ON PHONES ###
exports.reflow = ->
	if Utils.isPhone() or (Framer.Device.deviceType.substring 0, 12) is "apple-iphone"

		Artboard.backgroundColor = "white"
		
		Title.autoHeight = yes
		Title.width = Screen.width - 50
		Title.x = 20
		Title.y = 12
		Title.fontSize = 35
		Title.color = "black"
		
		Subtitle.width = Screen.width - 50
		Subtitle.x = 20
		Subtitle.y = Title.maxY + 3
		Subtitle.autoHeight = yes
		Subtitle.fontSize = 25
		Subtitle.color = "black"
		
		if Screen.height < 667
			if exports.subTitleOnIphone5 is no
				Subtitle.maxY = Title.maxY
				Subtitle.visible = no
		else
			if exports.subTitleOnIphone6 is no
				Subtitle.maxY = Title.maxY
				Subtitle.visible = no

		if @gridOrLine is "grid"
			grid.width = Screen.width - 40 - ( (Screen.width - 40) % 10 )
			grid.height = exports.gridHeightForiPhone6
			if Screen.height < 667
				grid.height = exports.gridHeightForiPhone5

			grid.borderWidth = 0.5
			grid.borderColor = "rgba(0,0,0,1)"
		else 
			grid.width = Screen.width - 40

		grid.x = 20
		grid.y = Subtitle.maxY + 18
		
		exports.page.height = Screen.height - grid.maxY - 60 - 7
		exports.page.y = grid.maxY + 40 + 7

		if @gridOrLine is "line"
			exports.page.width = grid.width
			exports.page.height = Screen.height - grid.maxY - 40 - 7
			exports.page.y = grid.maxY + 20 + 7
			exports.page.x = 20

		scaleForLists = 1
		if Screen.height is 667 and exports.scaleForiPhone6 < 1
			scaleForLists = exports.scaleForiPhone6 
		else if Screen.height < 667 and exports.scaleForiPhone5 < 1
			scaleForLists = exports.scaleForiPhone5


		for container, i in exports.containers

			indicator = new Layer
				size: 7, borderRadius: "50%"
				backgroundColor: "black"
				x: (Screen.width/2) - (8*exports.containers.length) + (16 * i)
				y: grid.maxY + 20
				opacity: .3

			if @gridOrLine is "line"
				indicator.y = grid.maxY
			
			indicator.states.active =
				opacity: 1
				scale: 1.1
			indicator.animationOptions = time: 0.5
			
			exports.pageIndicators.push indicator


			wrapper = new Layer
				width: exports.page.width
				height: exports.page.height
				backgroundColor: null
		
			page = new Layer
				width: grid.width
				height: exports.page.height
				borderRadius: 10
				backgroundColor: container.name
				x: grid.x
				parent: wrapper

			if @gridOrLine is "line"
				page.x = 0
			
			container.x = 20
			container.y = 15
			container.parent = page
			container.scale = scaleForLists
			
			exports.page.addPage wrapper
			

		# Set indicator for the first page
		exports.pageIndicators[0].animate "active"

		# Update indicators
		exports.page.on "change:currentPage", ->
			indicator.animate "default" for indicator in exports.pageIndicators
			
			current = exports.page.horizontalPageIndex exports.page.currentPage
			exports.pageIndicators[current].animate "active"
